// This file was generated by qtwaylandscanner
// source file is /usr/share/plasma-wayland-protocols/outputdevice.xml

#ifndef QT_WAYLAND_SERVER_ORG_KDE_KWIN_OUTPUTDEVICE
#define QT_WAYLAND_SERVER_ORG_KDE_KWIN_OUTPUTDEVICE

#include "wayland-server-core.h"
#include "wayland-org-kde-kwin-outputdevice-server-protocol.h"
#include <QByteArray>
#include <QMultiMap>
#include <QString>

#ifndef WAYLAND_VERSION_CHECK
#define WAYLAND_VERSION_CHECK(major, minor, micro) \
    ((WAYLAND_VERSION_MAJOR > (major)) || \
    (WAYLAND_VERSION_MAJOR == (major) && WAYLAND_VERSION_MINOR > (minor)) || \
    (WAYLAND_VERSION_MAJOR == (major) && WAYLAND_VERSION_MINOR == (minor) && WAYLAND_VERSION_MICRO >= (micro)))
#endif

QT_BEGIN_NAMESPACE
QT_WARNING_PUSH
QT_WARNING_DISABLE_GCC("-Wmissing-field-initializers")
QT_WARNING_DISABLE_CLANG("-Wmissing-field-initializers")

namespace QtWaylandServer {
    class  org_kde_kwin_outputdevice
    {
    public:
        org_kde_kwin_outputdevice(struct ::wl_client *client, int id, int version);
        org_kde_kwin_outputdevice(struct ::wl_display *display, int version);
        org_kde_kwin_outputdevice(struct ::wl_resource *resource);
        org_kde_kwin_outputdevice();

        virtual ~org_kde_kwin_outputdevice();

        class Resource
        {
        public:
            Resource() : org_kde_kwin_outputdevice_object(nullptr), handle(nullptr) {}
            virtual ~Resource() {}

            org_kde_kwin_outputdevice *org_kde_kwin_outputdevice_object;
            org_kde_kwin_outputdevice *object() { return org_kde_kwin_outputdevice_object; } 
            struct ::wl_resource *handle;

            struct ::wl_client *client() const { return wl_resource_get_client(handle); }
            int version() const { return wl_resource_get_version(handle); }

            static Resource *fromResource(struct ::wl_resource *resource);
        };

        void init(struct ::wl_client *client, int id, int version);
        void init(struct ::wl_display *display, int version);
        void init(struct ::wl_resource *resource);

        Resource *add(struct ::wl_client *client, int version);
        Resource *add(struct ::wl_client *client, int id, int version);
        Resource *add(struct wl_list *resource_list, struct ::wl_client *client, int id, int version);

        Resource *resource() { return m_resource; }
        const Resource *resource() const { return m_resource; }

        QMultiMap<struct ::wl_client*, Resource*> resourceMap() { return m_resource_map; }
        const QMultiMap<struct ::wl_client*, Resource*> resourceMap() const { return m_resource_map; }

        bool isGlobalRemoved() const { return m_globalRemovedEvent; }
        void globalRemove();

        bool isGlobal() const { return m_global != nullptr; }
        bool isResource() const { return m_resource != nullptr; }

        static const struct ::wl_interface *interface();
        static QByteArray interfaceName() { return interface()->name; }
        static int interfaceVersion() { return interface()->version; }


        enum subpixel {
            subpixel_unknown = 0,
            subpixel_none = 1,
            subpixel_horizontal_rgb = 2,
            subpixel_horizontal_bgr = 3,
            subpixel_vertical_rgb = 4,
            subpixel_vertical_bgr = 5,
        };

        enum transform {
            transform_normal = 0,
            transform_90 = 1,
            transform_180 = 2,
            transform_270 = 3,
            transform_flipped = 4,
            transform_flipped_90 = 5,
            transform_flipped_180 = 6,
            transform_flipped_270 = 7,
        };

        enum mode {
            mode_current = 0x1, // indicates this is the current mode
            mode_preferred = 0x2, // indicates this is the preferred mode
        };

        enum enablement {
            enablement_disabled = 0,
            enablement_enabled = 1,
        };

        enum capability {
            capability_overscan = 1, // if this outputdevice can use overscan
            capability_vrr = 2, // if this outputdevice supports variable refresh rate
        };

        enum vrr_policy {
            vrr_policy_never = 0,
            vrr_policy_always = 1,
            vrr_policy_automatic = 2,
        };

        void send_geometry(int32_t x, int32_t y, int32_t physical_width, int32_t physical_height, int32_t subpixel, const QString &make, const QString &model, int32_t transform);
        void send_geometry(struct ::wl_resource *resource, int32_t x, int32_t y, int32_t physical_width, int32_t physical_height, int32_t subpixel, const QString &make, const QString &model, int32_t transform);
        void send_mode(uint32_t flags, int32_t width, int32_t height, int32_t refresh, int32_t mode_id);
        void send_mode(struct ::wl_resource *resource, uint32_t flags, int32_t width, int32_t height, int32_t refresh, int32_t mode_id);
        void send_done();
        void send_done(struct ::wl_resource *resource);
        void send_scale(int32_t factor);
        void send_scale(struct ::wl_resource *resource, int32_t factor);
        void send_edid(const QString &raw);
        void send_edid(struct ::wl_resource *resource, const QString &raw);
        void send_enabled(int32_t enabled);
        void send_enabled(struct ::wl_resource *resource, int32_t enabled);
        void send_uuid(const QString &uuid);
        void send_uuid(struct ::wl_resource *resource, const QString &uuid);
        void send_scalef(wl_fixed_t factor);
        void send_scalef(struct ::wl_resource *resource, wl_fixed_t factor);
        void send_colorcurves(const QByteArray &red, const QByteArray &green, const QByteArray &blue);
        void send_colorcurves(struct ::wl_resource *resource, const QByteArray &red, const QByteArray &green, const QByteArray &blue);
        void send_serial_number(const QString &serialNumber);
        void send_serial_number(struct ::wl_resource *resource, const QString &serialNumber);
        void send_eisa_id(const QString &eisaId);
        void send_eisa_id(struct ::wl_resource *resource, const QString &eisaId);
        void send_capabilities(uint32_t flags);
        void send_capabilities(struct ::wl_resource *resource, uint32_t flags);
        void send_overscan(uint32_t overscan);
        void send_overscan(struct ::wl_resource *resource, uint32_t overscan);
        void send_vrr_policy(uint32_t vrr_policy);
        void send_vrr_policy(struct ::wl_resource *resource, uint32_t vrr_policy);

    protected:
        virtual Resource *org_kde_kwin_outputdevice_allocate();

        virtual void org_kde_kwin_outputdevice_destroy_global();

        virtual void org_kde_kwin_outputdevice_bind_resource(Resource *resource);
        virtual void org_kde_kwin_outputdevice_destroy_resource(Resource *resource);

    private:
        static void bind_func(struct ::wl_client *client, void *data, uint32_t version, uint32_t id);
        static void destroy_func(struct ::wl_resource *client_resource);
        static void display_destroy_func(struct ::wl_listener *listener, void *data);
        static int deferred_destroy_global_func(void *data);

        Resource *bind(struct ::wl_client *client, uint32_t id, int version);
        Resource *bind(struct ::wl_resource *handle);

        QMultiMap<struct ::wl_client*, Resource*> m_resource_map;
        Resource *m_resource;
        struct ::wl_global *m_global;
        struct ::wl_display *m_display;
        struct wl_event_source *m_globalRemovedEvent;
        struct DisplayDestroyedListener : ::wl_listener {
            org_kde_kwin_outputdevice *parent;
        };
        DisplayDestroyedListener m_displayDestroyedListener;
    };
}

QT_WARNING_POP
QT_END_NAMESPACE

#endif
